<?php

global $page, $conf, $template;

// Return picture lightbox picture URL for known extension
function get_lightbox_url($picture)
{
  global $conf, $py_addext;

  $ext = get_extension($picture['file']);
  if (in_array($ext, $conf['picture_ext']))
  {
    return $picture['path'];
  }
  elseif (in_array($ext, $py_addext))
  {
    return get_root_url().'plugins/lightbox/get_content.php?imgid='.$picture['id'];
  }
  return false;
}

// Return lightbox title
function get_lightbox_title($picture, $name_link)
{
  global $conf, $user;

  if (isset($picture['name']) and $picture['name'] != '')
  {
    $name = $picture['name'];
  }
  else
  {
    $name = str_replace('_', ' ', get_filename_wo_extension($picture['file']));
  }

  if ($name_link == 'picture')
  {
    $url = duplicate_picture_url(
      array(
        'image_id' => $picture['id'],
        'image_file' => $picture['file']
      ),
      array('start')
    );
    return htmlspecialchars('<a href="'.$url.'">'.$name.'</a>');
  }
  elseif ($name_link == 'high' and $picture['has_high'] and $user['enabled_high']=='true')
  {
    include_once(PHPWG_ROOT_PATH . 'include/functions_picture.inc.php');
    return htmlspecialchars('<a href="javascript:phpWGOpenWindow(\''.get_high_url($picture).'\',\'\',\'scrollbars=yes,toolbar=no,status=no,resizable=yes\')">'.$name.'</a>');
  }
  return $name;
}

// Return extra picture for multipage category
function get_lightbox_extra_pictures($selection, $rank_of, $name_link)
{
  $query = 'SELECT * FROM '.IMAGES_TABLE.' WHERE id IN ('.implode(',', $selection).');';
  $result = pwg_query($query);
  $pictures = array();
  while ($row = mysql_fetch_assoc($result))
  {
    $row['rank'] = $rank_of[ $row['id'] ];
    array_push($pictures, $row);
  }
  usort($pictures, 'rank_compare');
  
  $content = '<div class="thumbnails" style="display: none;">'."\n";
  foreach ($pictures as $picture)
  {
    $content .= '<a href="#" id="img-'.$picture['id'].'" name="'.get_lightbox_url($picture).'" title="'.get_lightbox_title($picture, $name_link).'" rel="colorbox"></a>'."\n";
  }
  $content .= '</div>'."\n";
  
  return $content;
}
 
  
include(dirname(__FILE__).'/admin/config_default.inc.php');
$params = unserialize($conf['lightbox']);

$template->func_known_script(array('id'=>'jquery', 'src'=>get_root_url().'plugins/lightbox/jquery.min.js'), $smarty);
$template->func_known_script(array('id'=>'colorbox', 'src'=>get_root_url().'plugins/lightbox/jquery.colorbox.js'), $smarty);
$template->block_html_head('', '
<link rel="stylesheet" href="'.get_root_url().'plugins/lightbox/colorbox.css" type="text/css" media="screen">
<link rel="stylesheet" href="'.get_root_url().'plugins/lightbox/theme/'.$params['theme'].'/theme.css" type="text/css" media="screen">
<!--[if IE]>
  <link type="text/css" media="screen" rel="stylesheet" href="'.get_root_url().'plugins/lightbox/theme/'.$params['theme'].'/theme-ie.css" title="example">
<![endif]-->
<script type="text/javascript">
$(document).ready(function(){
$(".thumbnails a").attr("href", function () {
  return this.name;    
});
$(".thumbnails a").colorbox({
  contentCurrent: "",
  transition: "'.$params['transition'].'",
  transitionSpeed: "'.$params['transition_speed'].'",
  initialWidth: "'.(!empty($params['initial_width']) ? $params['initial_width'] : $config_default['initial_width']).'",
  initialHeight: "'.(!empty($params['initial_height']) ? $params['initial_height'] : $config_default['initial_height']).'",
  fixedWidth: '.(!empty($params['fixed_width']) ? '"'.$params['fixed_width'].'"' : 'false').',
  fixedHeight: '.(!empty($params['fixed_height']) ? '"'.$params['fixed_height'].'"' : 'false').'
  },
  function(img) { 
    $.post("'.get_root_url().'plugins/lightbox/save_history.php", {
      imgid:   img.id,
      catid:   "'.@$page['category']['id'].'",
      section: "'.@$page['section'].'",
      tagids:  "'.@implode(',', @$page['tag_ids']).'"
  });
});
});
</script>', $smarty, $repeat);

foreach($tpl_thumbnails_var as $key => $tpl_var)
{
  // Image URL for lightbox
  if ($newurl = get_lightbox_url($pictures[$key]))
  {
    $tpl_thumbnails_var[$key]['URL'] .= '" id="img-'.$pictures[$key]['id'].'" name="'.$newurl;
  }
  else
  {
    continue;
  }

  // Title display
  if ($params['display_name'])
  {
    $tpl_thumbnails_var[$key]['URL'] .= '" title="'.get_lightbox_title($pictures[$key], $params['name_link']);
  }

  // Arrows display
  if ($params['display_arrows'])
  {
    $tpl_thumbnails_var[$key]['URL'] .= '" rel="colorbox';
  }
}

// Add all items from category
if ($params['display_arrows'] and $params['all_cat'] and count($page['items']) > $page['nb_image_page'])
{
  $rank_of = array_flip($page['items']);
  if ($page['start'] > 0)
  {
    $selection = array_slice($page['items'], 0, $page['start']);
    $template->concat('PLUGIN_INDEX_CONTENT_BEGIN', get_lightbox_extra_pictures($selection, $rank_of, $params['name_link']));
  }

  if (count($page['items']) > $page['start'] + $page['nb_image_page'])
  {
    $selection = array_slice($page['items'], $page['start'] + $page['nb_image_page']);
    $template->concat('PLUGIN_INDEX_CONTENT_END', get_lightbox_extra_pictures($selection, $rank_of, $params['name_link']));
  }
}

?>